<?php
/*
 *   This file is part of NOALYSS.
 *
 *   NOALYSS is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   NOALYSS is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with NOALYSS; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// Copyright Author Dany De Bontridder danydb@aevalys.eu 14/11/24
/*! 
 * \file
 * \brief a retrieve info from Accountancy Ledger and copy them into the payment : Name , bank account and communication
 * \see Noalyss\XMLPayment\Operation_MTable->input
 */
/**
 * @var $http defined previously in ajax.php : object HttpInput
 * @var $cn Database object
 */
if (!defined('ALLOWED')) {
    die ("not allowed");
}
try {
    $jrn_id=$http->get('jr_id','number');
    $payment_detail_id=$http->get('d_id','number');
} catch (\Exception $e) {
    echo $e->getMessage();
    return;
}


// display json
$answer=\Noalyss\XMLPayment\Operation::make_info($jrn_id);

echo json_response($answer);