<?php
/*
 *   This file is part of NOALYSS.
 *
 *   NOALYSS is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   NOALYSS is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with NOALYSS; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// Copyright Author Dany De Bontridder danydb@aevalys.eu 24/09/24
/*! 
 * \file
 * \brief make the XML for bank
 *
 */
if (!defined('ALLOWED'))
    die('Appel direct ne sont pas permis');
$http=new \HttpInput();
try {
    $iban=$http->get('bank_iban');
    $name=$http->get('bank_name');
    $bic=$http->get('bank_bic');
    $payment_id=$http->get('p_id','number');
} catch (\Exception $e) {
    echo $e->getMessage();
    return;
}
$sepa=new \Noalyss\XMLPayment\Sepa($payment_id);
$error=$sepa->verify();
$msg="";
if ($error['amount'] !=0 ) {
    $msg.=p(sprintf('nombre de virements avec un montant invalide %s',$error['amount']));
}
if ($error['card'] !=0 ) {
    $msg.=p(sprintf('nombre de virements avec une fiche invalide %s<p>',$error['card']));
}
if ($error['iban'] !=0 ) {
    $msg.=p(sprintf('nombre de virements avec un compte en banque invalide %s',$error['iban']));
}

if ($error['valid'] ==0 ) {
    $msg.=p(sprintf('aucun virement trouvé'));
}
$answer=[];
if (trim($msg)=="") {
    $answer['status']="OK";
    $answer['xml']=$sepa->build_xml()->saveXML();
} else {
    $answer['status']="NOK";
    $answer['data']=$msg;
    $operation_mtable = \Noalyss\XMLPayment\Operation_MTable::build(0, $payment_id);
    $operation_mtable->set_object_name('payment_detail_mtable');
    $ret=$operation_mtable->execute_query(' where payment_id=$1',[$payment_id] );
    $nb=\Database::num_row($ret);
ob_start();
    printf('<table class="result" id="tb%s">', $operation_mtable->get_object_name());
    $operation_mtable->display_table_header();
    echo '<tbody>';
    for ($i=0; $i<$nb; $i++)
    {
        $row=Database::fetch_array($ret, $i);
        $operation_mtable->display_row($row);
    }
    echo '</tbody>';
    echo "</table>";
    $answer['xml']=ob_get_contents();
    ob_end_clean();
}
echo json_response($answer);

