<?php
/*
 *   This file is part of NOALYSS.
 *
 *   NOALYSS is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   NOALYSS is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with NOALYSS; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// Copyright Author Dany De Bontridder danydb@aevalys.eu 19/09/24
/*! 
 * \file
 * \brief answer to ajax : add , modify or delete a row (= payment) in a SEPA list
 */
global $g_user,$g_config_xmlpay;

if ( ! defined ('ALLOWED') ) {
    die ("not allowed");
}

$http=new HttpInput();

try {
    $table=$http->request('table');
    $action=$http->request('action');
    $p_id=$http->request('p_id', "number");
    $payment_id=$http->request('payment_id', "number");
    $ctl_id=$http->request('ctl');
} catch(Exception $e) {
    echo $e->getMessage();
    return;
}
$manage_table=\Noalyss\XMLPayment\Operation_MTable::build($p_id,$payment_id);
$manage_table->set_object_name($ctl_id);
$manage_table->send_header();

if ($action=="input")
{
    echo $manage_table->ajax_input()->saveXML();
    return;
} elseif ($action=="save")
{
    // reset error code
    $g_config_xmlpay['cn']->exec_sql('update xmlpayment.payment_detail set d_error=0 where d_id=$1',[$p_id]);
    echo $manage_table->ajax_save()->saveXML();
    return;
}elseif ($action=="delete")
{
    echo $manage_table->ajax_delete()->saveXML();
    return;
}
