<?php
/*
 *   This file is part of NOALYSS.
 *
 *   NOALYSS is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   NOALYSS is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with NOALYSS; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// Copyright Author Dany De Bontridder danydb@aevalys.eu 7/10/24
/*! 
 * \file
 * \brief save bank info
 * Parameters
 * \code
   'act' => string 'save_bank' (length=9)
  'ac' => string 'COMPTA/MENUACH/XMLPY' (length=20)
  'gDossier' => string '74' (length=2)
  'plugin_code' => string 'XMLPY' (length=5)
  'bank_account_id' => string '1' (length=1)
  'bank_name' => string 'Compte courant ING' (length=18)
  'bank_iban' => string 'BE54548781826200' (length=16)
  'bank_bic' => string 'BIBRGEBB' (length=8)
  'bank_id' => string '1' (length=1)
  'p_id' => string '4' (length=1)
  'status' => string 'N' (length=1)
  'deposit_date' => string '' (length=0)
  'p_comment' => string '' (length=0)
 * \endcode
 */
if ( ! defined ('ALLOWED') ) {     die ("not allowed"); }


try {
    $http=new \HttpInput();
    $bank_account_id=$http->post('bank_account_id','number');
    $bank_name=$http->post('bank_name');
    $bank_iban=$http->post('bank_iban');
    $bank_bic=$http->post('bank_bic');
    $status=$http->post('status');
    $deposit_date=$http->post('deposit_date');
    $p_comment=$http->post('p_comment');
    $payment_id=$http->post('p_id','number');
    $exec_date=$http->post('p_exec_date');
} catch (\Exception $e) {
    echo $e->getMessage();
    return;
}
$cn=\Dossier::connect();

//-------------------------------------------------------------------------------------------
// save bank info
//-------------------------------------------------------------------------------------------
$bank_account_sql=new \Noalyss\XMLPayment\Bank_Account_SQL($cn,$bank_account_id);
$bank_account_sql->set('b_bank_number',$bank_iban)->set('b_bank_id',$bank_bic)->set('b_name_account',$bank_name);

$bank_account_sql->save();

//-------------------------------------------------------------------------------------------
// save xmlpayment.payment
//-------------------------------------------------------------------------------------------
$payment_sql=new \Noalyss\XMLPayment\Payment_SQL($cn,$payment_id);

$payment_sql->setp('p_date',$deposit_date);

$payment_sql->setp('bank_account_id',$bank_account_sql->getp('b_id'));
$payment_sql->setp('p_comment',$p_comment);
$payment_sql->setp('p_status',$status);
$payment_sql->setp('p_exec_date',$exec_date);
$payment_sql->save();

// ISelect choose the bank account
$select_bank=new ISelect("bank_account_id");
$select_bank->value=$cn->make_array("select b_id , format('%s [%s]',b_name_account,b_bank_number) str_bank 
    from xmlpayment.bank_account order by 1");
$select_bank->value[]=['value'=>-1,'label'=>_('*** Nouveau ***')];
$bank_id=$payment_sql->get("bank_account_id");
$select_bank->selected=$bank_id;
$select_bank->javascript='onchange="xmlPayment.change_bank();return false;"';

$answer['select']=$select_bank->input();


echo json_response($answer);