<?php
/*
 *   This file is part of NOALYSS.
 *
 *   NOALYSS is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   NOALYSS is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with NOALYSS; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// Copyright Author Dany De Bontridder danydb@aevalys.eu 7/11/24
/*! 
 * \file
 * \brief search for operations to add them to the list of SEPA
 */

if (!defined('ALLOWED')) {
    die ("not allowed");
}

/**
 * @var $op comes from $_GET['op'] , that is the parameter from ajax to select the action (route) to perform.
 * @var $g_user type of Noalyss_User , connected user
 */

global $http;

/* Admin. Dossier */
$cn = Dossier::connect();

// prefix for the ID  of the dialog box
$target=$http->get('target');

// object for searching ledger
$ledger = new Noalyss\XMLPayment\Ledger_Search('ALL', 1, $target);
$action = "";
$callback = "";

echo HtmlInput::title_box(_('Recherche opérations à ajouter'), $target);
echo '<form name="multi_search_form_ajx" id="multi_search_form_ajx" onsubmit="xmlPayment.search_multi_operation(this);return false">';
echo HtmlInput::get_to_hidden(array('list_id', 'ledger','mtable_id'));
echo HtmlInput::hidden("target", $target);
$inside = true;

// if there is the first call, put a filter on PURCHASE LEDGER
$first=$http->request("first","number",0);
if ( $first == 0 ) {
    // retrieve all the purchase ledgers , the user can access
    $aPurchase=$g_user->get_ledger('ACH',3);
    if ( $aPurchase != null ) {
        // put these ledger id in HIDDEN
       if (DEBUGNOALYSS > 1 ) echo  \Noalyss\Dbg::hidden_info("Purchase ledger", $aPurchase);
       $nb_purchase=count($aPurchase);

       echo put_global([["key"=>"{$target}nb_jrn","value"=>$nb_purchase]]);
       for($i=0;$i<$nb_purchase;$i++) {
            echo \HtmlInput::hidden("{$target}r_jrn[{$i}]", $aPurchase[$i]['jrn_def_id']);
            $_GET["{$target}r_jrn"][]=$aPurchase[$i]['jrn_def_id'];
            $_REQUEST["{$target}r_jrn"][]=$aPurchase[$i]['jrn_def_id'];

       }
    }
}
$first++;
echo HtmlInput::hidden("first", $first);

// display the FORM
echo $ledger->search_form();
// Variable : list id and Manage table id

echo '<ul  class="aligned-block">';
echo '<li>';
echo HtmlInput::submit("viewsearch", _("Recherche"));
echo '</li>';
echo '<li>';
echo HtmlInput::button_close($target);
echo '</li>';
echo '</ul>';
echo '</form>';

//-----------------------------------------------------
// Display search result, value from the search FORM
//
//-----------------------------------------------------
if (isset($_GET['viewsearch'])) {

    // Navigation bar
    $step = MAX_RECONCILE;
    $page = $http->get("page", "number", 1);
    $offset = $http->get("offset", "number", 0);

    if (count($_GET) == 0)
        $array = null;
    else
        $array = $_GET;

    $array['p_action'] = 'ALL';
    if (!isset($array['date_start']) || !isset($array['date_end'])) {
        // get first date of current exercice
        list($array['date_start'], $array['date_end']) = $g_user->get_limit_current_exercice();
    }


    list($sql, $where) = $ledger->build_search_sql($array);
    // Count nb of line
    $max_line = $cn->count_sql($sql);

    list($count, $content) = $ledger->list_operation_to_reconcile($sql,$target);
    $bar = navigation_bar($offset, $max_line, $step, $page);


    if ($step < $max_line) {
        echo '<h2 class="notice">' . _('Liste limitée à ') . $step . _(' enregistrements. Le nombre d\'enregistrements trouvés est de ') . $max_line . '</h2>';
    }
    echo '<form method="POST" onsubmit="xmlPayment.payment_add_list(this);return false">';

    echo HtmlInput::hidden("first", $first);
    echo HtmlInput::request_to_hidden(array('list_id', 'ledger','mtable_id'));

    echo '<ul class="aligned-block" style="padding:0;">';
    echo '<li>';
    echo HtmlInput::submit("add_operation1", _("Ajouter la sélection aux paiements"));
    echo '</li>';
    echo '</ul>';


    // display the FORM
    echo $ledger->search_form();

    echo $content;
    echo '<ul class="aligned-block">';
    echo '<li>';
    echo HtmlInput::submit("add_operation2", _("Ajouter la sélection aux paiements"));
    echo '</li>';
    echo '<li>';
    echo HtmlInput::button_close($target);
    echo '</li>';
    echo '</ul>';


    echo '</form>';
}
echo '</div>';

