<?php

namespace Noalyss\XMLPayment;

/*
 *   This file is part of NOALYSS.
 *
 *   NOALYSS is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   NOALYSS is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with NOALYSS; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// Copyright Author Dany De Bontridder danydb@aevalys.eu 7/11/24
/*! 
 * \file
 * \brief Like IConcerned
 */

/**
 * \class
 * \brief Like IConcerned
 */

class IConcerned
{
    protected $domid; //!< DOMID containing the result , type = input text in readonly mode
    protected $value; //!< JRN.JR_ID
    protected $var_javascript; //!< Javascript var. used in the page (default xmlPayment)

    function __construct($domid,$value,$var_javascript='xmlPayment')
    {
        $this->domid=$domid;
        $this->value=$value;
        $this->var_javascript=$var_javascript;
    }
    function input():string
    {
        $cn=\Dossier::connect();

        $javascript=sprintf("%s.search_reconcile('%s')",
                $this->var_javascript,
                $this->domid);

        $r=\Icon_Action::icon_magnifier(uniqid(), $javascript);

        $input=<<<INPUT
<INPUT TYPE="text"  style="color:black;background:lightyellow;border:solid 1px grey;"  NAME="%s" ID="%s" VALUE="%s" SIZE="8"  readonly >
<INPUT class="smallbutton"  TYPE="button" onClick="$('%s').value=''" value="X">
INPUT;
      
        $r.=sprintf($input,$this->domid,$this->domid,$this->value,$this->domid);

        if (isNumber($this->value) == 1) {
            $p_mesg=$cn->get_value('select coalesce(jr_pj_number,jr_internal) from jrn where jr_id=$1',[$this->value]);
            echo \HtmlInput::detail_op($this->value, $p_mesg);
        }
        return $r;
    }

}
