<?php

namespace Noalyss\XMLPayment;
/*
 *   This file is part of NOALYSS.
 *
 *   NOALYSS is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   NOALYSS is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with NOALYSS; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// Copyright Author Dany De Bontridder danydb@aevalys.eu 20/11/24
/*! 
 * \file
 * \brief Child of Acc_Ledger_Search
 */
use Database;
use Dossier;
use HtmlInput;

class Ledger_Search extends \Acc_Ledger_Search
{
    /**
     * @brief Show all the operation
     * @param$sql is the sql stmt, normally created by build_search_sql
     * @param$offset the offset
     * @return HTML string
     */
    public function list_operation_to_reconcile($sql, $p_target)
    {
        global $g_parameter, $g_user;
        $gDossier = Dossier::id();
        $limit = " LIMIT " . MAX_RECONCILE;
        // Sort
        // Count
        $count = $this->cn->count_sql($sql);
        // Add the limit
        $sql .= " order by jr_date asc " . $limit;

        // Execute SQL stmt
        $Res = $this->cn->exec_sql($sql);

        //starting from here we can refactor, so that instead of returning the generated HTML,
        //this function returns a tree structure.

        $r = "";


        $Max = Database::num_row($Res);

        if ($Max == 0)
            return array(0, _("Aucun enregistrement trouvé"));
        $r .= HtmlInput::hidden("target", $p_target);
        $r .= '<table class="result">';


        $r .= "<tr >";
        $r .= "<th>" . _("Selection") . "</th>";
        $r .= "<th>" . _("Internal") . "</th>";

        if ($this->get_type() == 'ALL') {
            $r .= th(_('Journal'));
        }

        $r .= '<th>' . _("Date") . '</th>';
        $r .= '<th>' . _("Pièce") . '</td>';
        $r .= th(_('tiers'));
        $r .= '<th>' . _("Description") . '</th>';
        $r .= th(_('Notes'), ' ');
        $r .= '<th>' . _("Montant") . '</th>';

        $r .= "</tr>";
        // Total Amount
        $tot = 0.0;
        $gDossier = dossier::id();
        $str_dossier = Dossier::id();
        for ($i = 0; $i < $Max; $i++) {


            $row = Database::fetch_array($Res, $i);

            if ($i % 2 == 0)
                $tr = '<TR class="odd">';
            else
                $tr = '<TR class="even">';
            $r .= $tr;
            // Radiobox
            //

            $r .= '<td><INPUT TYPE="CHECKBOX" name="jr_concerned' . $row['jr_id'] . '" ID="jr_concerned' . $row['jr_id'] . '" value="' . $row['quick_code'] . '"> </td>';
            //internal code
            // button  modify
            $r .= "<TD>";
            // If url contains
            //

            $href = basename($_SERVER['PHP_SELF']);


            $r .= sprintf('<A class="detail" style="text-decoration:underline" HREF="javascript:modifyOperation(\'%s\',\'%s\')" >%s </A>',
                $row['jr_id'], $gDossier, $row['jr_internal']);
            $r .= "</TD>";
            if ($this->get_type() == 'ALL')
                $r .= td($row['jrn_def_name']);
            // date
            $r .= "<TD>";
            $r .= $row['str_jr_date'];
            $r .= "</TD>";

            // pj
            $r .= "<TD>";
            $r .= $row['jr_pj_number'];
            $r .= "</TD>";

            // Tiers
            $other = ($row['quick_code'] != '') ? '[' . $row['quick_code'] . '] ' . $row['name'] . ' ' . $row['first_name'] : '';
            $r .= td($other);
            // comment
            $r .= "<TD>";
            $tmp_jr_comment = h($row['jr_comment']) . $row['tag_operation'];
            $r .= $tmp_jr_comment;
            $r .= "</TD>";
            $r .= td(h($row['n_text']), ' style="font-size:0.87em"');
            // Amount
            // If the ledger is financial :
            // the credit must be negative and written in red
            $positive = 0;

            // Check ledger type :
            if ($row['jrn_def_type'] == 'FIN') {
                $positive = $this->cn->get_value("select qf_amount from quant_fin where jr_id=$1",
                    array($row['jr_id']));
                if ($this->cn->count() != 0)
                    $positive = ($positive < 0) ? 1 : 0;
            }
            $r .= "<TD align=\"right\">";

            $r .= ($positive != 0) ? "<font color=\"red\">  - " . nbm($row['total_invoice']) . "</font>" : nbm($row['total_invoice']);
            $r .= "</TD>";




            if ($row['jr_valid'] == 'f') {
                $r .= "<TD>" . _("Opération annulée") . "</TD>";
            }
            // end row
            $r .= "</tr>";
        }
        $r .= '</table>';
        return array($count, $r);
    }
}