<?php
/*
 *   This file is part of NOALYSS.
 *
 *   NOALYSS is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   NOALYSS is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with NOALYSS; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// Copyright Author Dany De Bontridder danydb@aevalys.eu 13/09/24
/*! 
 * \file
 * \brief contains a set of payment order
 */
namespace Noalyss\XMLPayment;
use ISelect;
/*!
 * \class
 * \brief contains a set of payment order, SQL xmlpayment.payment
 */

class List_Operation
{


    /**
     * @brief display all lists
     * @return void
     */
    static function display_list()
    {
        global $g_config_xmlpay;


        require $g_config_xmlpay['dir']."/template/list_operation-display_list.php";
    }
    function __construct(protected  Payment_SQL $payment_sql)
    {
    }

    public function get_payment_sql(): Payment_SQL
    {
        return $this->payment_sql;
    }

    public function set_payment_sql(Payment_SQL $payment_sql): List_Operation
    {
        $this->payment_sql = $payment_sql;
        return $this;
    }

    /**
     * @brief select a bank account for this list and propose to add one if needed
     * @return void
     */
    public function select()
    {
        global $g_config_xmlpay;
        // DB connection
        $cn=$this->payment_sql->cn;

        // ISelect choose the bank account
        $select_bank=new ISelect("bank_account_id");

        $select_bank->value=$cn->make_array("select b_id , format('%s [%s]',b_name_account,b_bank_number) str_bank from xmlpayment.bank_account order by 1",1);
        $select_bank->selected=$this->payment_sql->get("bank_account_id");

        require $g_config_xmlpay['dir'].'/template/list_operation-select.php';

    }

}