<?php

/**
 *   This file is part of NOALYSS
 *
 *   NOALYSS is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   NOALYSS is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with NOALYSS; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * copyright Dany WM De Bontridder($(YEAR))
 *
 *  $(DATE)
 */

/**
 * @file
 * @brief abstract of the table xmlpayment.bank_account
 */
namespace Noalyss\XMLPayment;
/**
 * @class
 * @brief  abstract of the table xmlpayment.bank_account
 */
class  Bank_Account_SQL extends \Table_Data_SQL
{

    function __construct(\DatabaseCore $p_cn, $p_id = -1)
    {
        $this->table = "xmlpayment.bank_account";
        $this->primary_key = "b_id";
        /*
         * List of columns
         */
        $this->name = array(
            "b_id" => "b_id",
            "b_bank_number" => "b_bank_number",
            "b_bank_id" => "b_bank_id",
            "b_name_account" => "b_name_account",

        );
        /*
         * Type of columns
         */
        $this->type = array(
            "b_id" => "numeric",
            "b_bank_number" => "text",
            "b_bank_id" => "text",
            "b_name_account" => "text"
        );


        $this->default = array(
            "b_id" => "auto"
        );

        $this->date_format = "DD.MM.YYYY";
        parent::__construct($p_cn, $p_id);
    }


}