<?php

/**
 *   This file is part of NOALYSS
 *
 *   NOALYSS is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   NOALYSS is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with NOALYSS; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * copyright Dany WM De Bontridder($(YEAR))
 *
 *  $(DATE)
 */

/**
 * @file
 * @brief abstract of the table
 */

/**
 * @class
 * @brief  abstract of the table
 */

namespace Noalyss\XMLPayment;

class Payment_Detail_SQL extends \Table_Data_SQL
{

    function __construct(\DatabaseCore $p_cn, $p_id = -1)
    {
        $this->table = "xmlpayment.payment_detail";
        $this->primary_key = "d_id";
        /*
         * List of columns
         */
        $this->name = array(
            "d_id" => "d_id",
            "d_amount" => "d_amount",
            "d_bank_account" => "d_bank_account",
            "fiche_id" => "fiche_id",
            "d_message" => "d_message",
            "payment_id" => "payment_id",
            "d_jr_id"=>"d_jr_id",
            "d_error"=>"d_error",
            "tech_user" => "tech_user",
            "tech_date" => "tech_date"
        );
        /*
         * Type of columns
         */
        $this->type = array(
            "d_id" => "numeric",
            "d_amount" => "numeric",
            "d_bank_account" => "text",
            "fiche_id" => "numeric",
            "d_message" => "text",
            "payment_id" => "numeric",
            "d_jr_id"=>"numeric",
            "tech_user" => "text",
            "d_error"=>"number",
            "tech_date" => "text"
        );


        $this->default = array(
            "d_id" => "auto",
            "tech_user" => "auto",
            "tech_date" => "auto",
            "d_error"=>"auto"
        );

        $this->date_format = "DD.MM.YYYY HH24:MI";
        parent::__construct($p_cn, $p_id);
    }


}