<?php

/**
 *   This file is part of NOALYSS
 *
 *   NOALYSS is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   NOALYSS is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with NOALYSS; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * copyright Dany WM De Bontridder($(YEAR))
 *
 *  $(DATE)
 */

/**
 * @file
 * @brief abstract of the table
 */

/**
 * @class
 * @brief  abstract of the table
 */

namespace Noalyss\XMLPayment;

class Payment_SQL extends \Table_Data_SQL
{

    function __construct(\DatabaseCore $p_cn, $p_id = -1)
    {
        $this->table = "xmlpayment.payment";
        $this->primary_key = "p_id";
        /*
         * List of columns
         */
        $this->name = array(
            "p_id" => "p_id",
            "p_date" => "p_date",
            "p_status" => "p_status",
            "p_comment" => "p_comment",
            "bank_account_id"=>"bank_account_id",
            "tech_user" => "tech_user",
            "create_date" => "create_date",
            "tech_date" => "tech_date",
            "p_exec_date"=>"p_exec_date"

        );
        /*
         * Type of columns
         */
        $this->type = array(
            "p_id" => "numeric",
            "p_date" => "date",
            "p_status" => "text",
            "p_comment" => "text",
            "tech_user" => "text",
            "create_date" => "text",
            "tech_date" => "date",
            "bank_account_id"=>"numeric",
            "p_exec_date"=>'date'
        );


        $this->default = array(
            "p_id" => "auto",
            "tech_user" => "auto",
            "tech_date" => "auto",
            "create_date" => "auto"
        );

        $this->date_format = "DD.MM.YYYY";
        parent::__construct($p_cn, $p_id);
    }


}