<?php
/*
 *   This file is part of NOALYSS.
 *
 *   NOALYSS is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   NOALYSS is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with NOALYSS; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// Copyright Author Dany De Bontridder danydb@aevalys.eu 13/09/24
/*! 
 * \file
 * \brief display list of XML list
 */

global $g_config_xmlpay;
$aList=$g_config_xmlpay['cn']->get_array("select p_id,
       to_char(p_date,'DD.MM.YY') str_date,
       to_char(p_exec_date,'DD.MM.YY') str_exec_date,
       p_comment,p_status 
from  xmlpayment.payment order by p_id desc");

echo \HtmlInput::button_anchor("✚ "._("Ajout"),"do.php?".http_build_query(["ac"=>$g_config_xmlpay['ac']
            ,'plugin_code'=>$g_config_xmlpay['plugin_code']
            ,'gDossier'=>$g_config_xmlpay['dossier_id']
            ,'sa'=>"list_detail"
            ,'p_id'=>-1
    ]));
echo \HtmlInput::filter_table("list_payment_table", '0,1,2', 1);
?>
<table class="result" id="list_payment_table">
    <tr>
        <th style="text-align: center">N°</th>
        <th style="text-align: center">Date exécution</th>
        <th style="text-align: center">Date dépôt</th>
        <th style="text-align: center">Etat</th>
        <th class="num">Montant total</th>
        <th class="num">Nbre paiements</th>
        <th style="text-align: center">Commentaire</th>
        <th></th>

    </tr>
    <?php
    $ix=0;
    foreach ($aList as $item):
        $url="do.php?".http_build_query(["ac" => $g_config_xmlpay['ac'], 'plugin_code' => $g_config_xmlpay['plugin_code'],
                'gDossier'=>$g_config_xmlpay['dossier_id'],'sa'=>'list_detail','p_id'=>$item['p_id']]);
    $class=($ix%2==0)?'odd':'even';
    $ix++;
    $sum=$g_config_xmlpay['cn']->get_row("select sum(d_amount) sum_amount,count(d_id) count_id from xmlpayment.payment_detail where payment_id=$1",[$item['p_id']]);
    ?>
    <tr class="<?=$class?>" id="xmlpy<?=$item['p_id']?>">
        <td>
            <a href="<?=$url?>" class="">
                <?php
                echo $item['p_id'];
                ?>
            </a>
        </td>
        <td style="text-align: center">
            <?=$item['str_exec_date']?>
        </td>
        <td style="text-align: center">
            <?=$item['str_date']?>
        </td>
        <td style="text-align: center">
            <?php
            echo match($item['p_status']){
                'N'=>_("Brouillon"),
                'D'=>_("Déposé")
            };

            ?>
        </td>
        <td class="num">
            <?=nbm($sum['sum_amount'],2)?>
        </td>
        <td class="num">
            <?=$sum['count_id']?>

        </td>
        <td>
            <?=h($item['p_comment'])?>
        </td>
        <td style="color:red">
            <?=\Icon_Action::trash(uniqid(),"xmlPayment.list_delete('{$item['p_id']}')");?>
        </td>
    </tr>

    <?php
    endforeach;
    ?>

</table>


<?php
echo \HtmlInput::button_anchor("✚ "._("Ajout"),"do.php?".http_build_query(["ac"=>$g_config_xmlpay['ac']
        ,'plugin_code'=>$g_config_xmlpay['plugin_code']
        ,'gDossier'=>$g_config_xmlpay['dossier_id']
        ,'sa'=>"list_detail"
        ,'p_id'=>-1
    ]));
?>