<?php
/*
 *   This file is part of NOALYSS.
 *
 *   NOALYSS is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   NOALYSS is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with NOALYSS; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// Copyright Author Dany De Bontridder danydb@aevalys.eu 20/09/24
/*! 
 * \file
 * \brief form to select a bank account or to add one
 */
// DB connection
/**
 * @var $this \Noalyss\XMLPayment\List_Operation
 * @var $execution_date date date to execute the payment (inherited)
 * @var $deposit_date date deposit table (inherited)
 */
$cn=$this->payment_sql->cn;
$bank_id=$this->payment_sql->get("bank_account_id");


// ISelect choose the bank account
$select_bank=new ISelect("bank_account_id");
$select_bank->value=$cn->make_array("select b_id , format('%s [%s]',b_name_account,b_bank_number) str_bank 
    from xmlpayment.bank_account order by 1");
$select_bank->value[]=['value'=>-1,'label'=>_('*** Nouveau ***')];
$bank_id=$this->payment_sql->get("bank_account_id");
$select_bank->selected=($bank_id!="")?$bank_id:-1;
$select_bank->javascript='onchange="xmlPayment.change_bank();return false;"';

// status
$status=new ISelect('status');
$status->value=array(["value"=>'N','label'=>'Nouveau'],["value"=>'D','label'=>'Déposé']);
$status->selected=$this->payment_sql->get('p_status');

// comment
$textarea=new \ITextarea('p_comment');
$textarea->set_enrichText('plain');
$textarea->value=$this->payment_sql->get('p_comment');
$deposit_date=new \IDate('deposit_date');
$execution_date=new \IDate('p_exec_date');

$deposit_date->value=$this->payment_sql->get('p_date');
$execution_date->value=$this->payment_sql->get('p_exec_date');
?>


<form id="form_save_bank_formid" onsubmit="return false;" class="m-2">
    <label for="bank_account_id">Choisissez votre compte en banque</label>
   <?=$select_bank->input()?>

    <div id="infobank_id">
        <?=(new Noalyss\XMLPayment\Header_Bank())->input($bank_id)?>
    </div>
    <p>
    </p>
            <?php
            echo \HtmlInput::array_to_hidden(['ac', 'plugin_code',   'gDossier'], $_REQUEST);
            echo \HtmlInput::hidden('p_id', $this->payment_sql->get('p_id'));
            ?>
<div id="xml_info"></div>
    <label for="status">Etat</label> :<?=$status->input()?>
    <label for="deposit_date">Date dépôt </label><?=$deposit_date->input()?>
    <label for="execution_date">Date exécution </label><?=$execution_date->input()?>
    <button class="button" onclick="if ($('comment_zone').visible()) {$('comment_zone').hide() }else {$('comment_zone').show()}">Commentaire</button>
    <div id="comment_zone" style="display:none">
        <?=$textarea->input()?>

    </div>

    <ul class="aligned-block">
        <li>
            <button class="smallbutton" onclick="xmlPayment.save_bank();return false">Sauver</button>
        </li>
         <li>
            <button class="smallbutton" onclick="(xmlPayment.save_bank() && xmlPayment.make_xml());return false">Composer le XML pour dépôt</button>
        </li>
        <li>

        </li>
    </ul>
</form>



