<?php
/*
 *   This file is part of NOALYSS.
 *
 *   NOALYSS is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   NOALYSS is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with NOALYSS; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// Copyright Author Dany De Bontridder danydb@aevalys.eu 21/11/24
/*! 
 * \file
 * \brief test function verify from Sepa class
 */

require_once '../bootstrap.php';
/**
 * fill up DB
 */

$INSERT_BK=<<<EOF
INSERT INTO xmlpayment.bank_account (b_bank_number, b_bank_id, b_name_account) VALUES('BE03429946455684', 'BEBBRTTT', 'Compte courant') returning b_id;
EOF;

$cn=Dossier::connect();
$cn->start();
$bank_id=$cn->get_value($INSERT_BK);
echo "Create bank $bank_id \n";

$INSERT_PARENT=<<<EOF
INSERT INTO xmlpayment.payment (p_status, p_comment, bank_account_id) VALUES('N', NULL, $bank_id) returning p_id;
EOF;

$payment_id=$cn->get_value($INSERT_PARENT);
echo "Create Payment list #$payment_id";

$INSERT=<<<EOF
INSERT INTO xmlpayment.payment_detail (d_amount, d_bank_account, fiche_id, d_message, payment_id) VALUES(38.23, 'BE38979065724272', 11, NULL,$payment_id);
INSERT INTO xmlpayment.payment_detail (d_amount, d_bank_account, fiche_id, d_message, payment_id) VALUES(6.50, 'BEFOUNR', 11, 'MSG1',$payment_id);
INSERT INTO xmlpayment.payment_detail (d_amount, d_bank_account, fiche_id, d_message, payment_id) VALUES(48.76, 'BE70173227675625', 315, '111/1111/1111',$payment_id);
INSERT INTO xmlpayment.payment_detail (d_amount, d_bank_account, fiche_id, d_message, payment_id) VALUES(6.50, 'BEFOUNR', 11, 'MSG1',$payment_id);
INSERT INTO xmlpayment.payment_detail (d_amount, d_bank_account, fiche_id, d_message, payment_id) VALUES(653.30, NULL, 169, NULL,$payment_id);
INSERT INTO xmlpayment.payment_detail (d_amount, d_bank_account, fiche_id, d_message, payment_id) VALUES(174.90, NULL, 113, NULL,$payment_id);
INSERT INTO xmlpayment.payment_detail (d_amount, d_bank_account, fiche_id, d_message, payment_id) VALUES(234.00, 'BEFOUNR', 11, NULL,$payment_id);
INSERT INTO xmlpayment.payment_detail (d_amount, d_bank_account, fiche_id, d_message, payment_id) VALUES(-2.42, 'BE70173227675625', 315, NULL,$payment_id);
INSERT INTO xmlpayment.payment_detail (d_amount, d_bank_account, fiche_id, d_message, payment_id) VALUES(48.76, 'BE70173227675625', NULL, '111/1111/1111',$payment_id);
EOF;


$cn->exec_sql($INSERT);

$cn->commit();

$sepa=new \Noalyss\XMLPayment\Sepa($payment_id);
$answer=$sepa->verify();
print_r($answer);
$expected=array (
    'amount' => 1,
    'card' => 1,
    'iban' => 5,
    'valid' => 2,
);
$err=0;
foreach ($expected as $key=>$value) {
    if ( $value != $answer[$key]) {
        print "Erreur pour $key => $value\n";
        $err++;
    }
}
if ($err != 0 ) echo "ERREUR : $err !\n";

$cn->exec_sql("
    delete from xmlpayment.bank_account where b_bank_number='BE03429946455684';
    
  
");
