<?php
/*
 *   This file is part of NOALYSS.
 *
 *   NOALYSS is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   NOALYSS is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with NOALYSS; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// Copyright Author Dany De Bontridder danydb@aevalys.eu 8/10/24
/*! 
 * \file
 * \brief check Noalyss\XMLPayment\Tools::check_iban() function
 */
require_once '../bootstrap.php';
$aValue = array(
      ['FR2617569000405121911339Y14', true]
    , ['FR8917569000504392936779O14', true]
    , ['FR7214508000702383844671J92', true]
    , ['FR26169000405121911339Y14', false]
    , ['FR89569000504392936779O14', false]
    , ['FR72508000702383844671J92', false]
    , ['NL13ABNA2859176594', true]
    , ['NL51RABO8584700412', true]
    , ['NL03ABNA4880983179', true]
    , ['NL13ABNA285917694', false]
    , ['NL51RABO858470012', false]
    , ['N03ABNA488098379L', false]
    , ['BE59561771574126', true]
    , ['BE02631697478740', true]
    , ['BE92519646539923', true]
    , ['BE92519646539923', true]
    , ['111459561771574126', false]
    , ['1114026316974787401114', false]
    , ['1114925196465399231114', false]
);
$err=0;
foreach ($aValue as $aIban) {
    list($iban,$result)=$aIban;
    $correct=match($result) {true=>'Correct' , false=>'Incorrect'};
    print "$iban : $correct\t";
    if ( \Noalyss\XMLPayment\Tools::check_iban($iban) != $result ){
        $flag=match($result){true=>'True',false=>'False'};
        echo "Failed for $iban ".$flag."\n";
        $err++;
    }else {
        echo "Success \n";
    }
}

print "Nombre erreurs = $err\n";
