//This file is part of NOALYSS and is under GPL
//see LICENCE.
/**
 *javascript for XmlPayment , the class is XMLPayement , the variable created when the page is loaded is
 * xmlPayment
 */

function XMLPayment() {

}

/**
 * for the card, this function will complete the data , it is called by the autocomplete.
 * from "Add payment"
 */
XMLPayment.prototype.fillData = function (ctl) {
    let card_qcode = $(ctl).value;
    try {

        waiting_box();

        var queryString = {
            act: 'fillData',
            ac: access_code,
            gDossier: dossier_id,
            plugin_code: plugin_code,
            qcode: card_qcode
        };
        var action = new Ajax.Request(
            "ajax.php",
            {
                method: 'GET',
                parameters: queryString,
                onSuccess: function (req) {
                    remove_waiting_box();
                    if (req.responseText == 'NOCONX') {
                        reconnect();
                        return;
                    }
                    let json = req.responseJSON;

                    if ( $('d_bank_account').value =="")  $('d_bank_account').value = json['bankaccount'];
                    $('label_fiche').innerText = json['name'] + " " + json['firstname'];
                }
            }
        );
    } catch (e) {
        alert_box(e.message);
    }
}
XMLPayment.prototype.search_card_box = function (dom_object) {
    try {
        var dgbox = "xmlpy_search_card_box";
        waiting_box();
        removeDiv(dgbox);
        // For form , most of the parameters are in the FORM
        // method is then POST
        //var queryString=$(p_form_id).serialize(true);
        var queryString = {
            act: 'search_card_box',
            ac: access_code,
            gDossier: dossier_id,
            plugin_code: plugin_code,
        };
        if (dom_object != undefined) {
            queryString['page_card'] = dom_object['page_card'].value;
            queryString['inactive_card'] = dom_object['inactive_card'].value;
            queryString['query'] = dom_object['query'].value;
        } else {
            queryString['page_card'] = 0;
            queryString['inactive_card'] = 0;

        }
        var action = new Ajax.Request(
            "ajax.php",
            {
                method: 'GET',
                parameters: queryString,
                onFailure: ajax_misc_failure,
                onSuccess: function (req) {
                    remove_waiting_box();
                    if (req.responseText == 'NOCONX') {
                        reconnect();
                        return;
                    }
                    var y = calcy(15);
                    var div_style = "position:absolute;" + ";top:" + y + "px";
                    add_div({id: dgbox, cssclass: 'inner_box', html: loading(), style: div_style, drag: true});
                    $(dgbox).update(req.responseText);

                }
            }
        );
    } catch (e) {
        alert_box(e.message);
    }

}

XMLPayment.prototype.check_input_bank = function () {
    let aRequireValue = ['bank_name', 'bank_iban', 'bank_bic'];
    var nb_err = 0;
    aRequireValue.forEach((require_input) => {
        if ($F(require_input).trim() == '') {
            $(require_input).addClassName('input-error');
            nb_err++;
        } else {
            $(require_input).removeClassName('input-error');
        }
    });
    return nb_err;
}
/**
 * Compose a XML with sepa
 * @returns {boolean}
 */
XMLPayment.prototype.make_xml = function () {
    try {
        let nb_err = this.check_input_bank();
        if (nb_err > 0) {
            return false;
        }

        waiting_box();
        // For form , most of the parameters are in the FORM
        // method is then POST
        //var queryString=$(p_form_id).serialize(true);

        var formParameter = $(form_save_bank_formid).serialize(true);
        var queryString = {
            act: 'make_xml',
            ac: access_code,
            gDossier: dossier_id,
            plugin_code: plugin_code,
            ...formParameter
        };

        var action = new Ajax.Request(
            "ajax.php",
            {
                method: 'GET',
                parameters: queryString,
                onFailure: ajax_misc_failure,
                onSuccess: function (req) {
                    remove_waiting_box();
                    if (req.responseText == 'NOCONX') {
                        reconnect();
                        return;
                    }
                    var json=req.responseJSON;
                    if (json['status'] == 'OK')
                    {
                        var data = json['xml'];
                        const a=new Date();
                        var strTimestamp=a.getFullYear().toString()+a.getMonth().toString()+a.getDate()+"-"+a.getHours()+a.getMinutes();
                        var filename="sepa-"+formParameter['p_id']+"-"+strTimestamp+".xml"
                        const blob = new Blob([data], {type: 'application/bin'});
                        const elem = window.document.createElement('a');
                        elem.href = window.URL.createObjectURL(blob);
                        elem.download = filename;
                        document.body.appendChild(elem);
                        elem.click();
                        document.body.removeChild(elem);
                        smoke.signal('Fichier envoyé <b>'+filename+'</b>',function(){},{duration:2000})
                    } else {
                        alert_box(json['data']);
                        $('tbpayment_detail_mtable').update(json['xml']);
                    }
                }
            }

        );
    } catch (e) {

        console.error(`XMLPayment.make_xml error ${e.message}`);
    }
    return true;
}


XMLPayment.prototype.change_bank = function () {
    try {
        let nBank_id = $('bank_account_id').value;
        if (nBank_id == -1) {
            $('bank_name').value = '';
            $('bank_iban').value = '';
            $('bank_bic').value = '';
            $('bank_account_id').value = -1
            $('bank_account_id').setStyle('font-style:italic');
            $('deletebk_div').hide();
            return;
        }
        $('deletebk_div').show();
        $('bank_account_id').setStyle('font-style:normal');
        waiting_box();
        var queryString = {
            act: 'change_bank',
            ac: access_code,
            gDossier: dossier_id,
            plugin_code: plugin_code,
            bank_id: nBank_id
        };

        var action = new Ajax.Request(
            "ajax.php",
            {
                method: 'GET',
                parameters: queryString,
                onFailure: ajax_misc_failure,
                onSuccess: function (req) {
                    remove_waiting_box();
                    if (req.responseText == 'NOCONX') {
                        reconnect();
                        return;
                    }
                    var json = req.responseJSON;
                    $('bank_name').value = json.bank_name;
                    $('bank_iban').value = json.bank_iban;
                    $('bank_bic').value = json.bank_bic;

                }
            }
        );
    } catch (e) {
        alert_box(e.message);
    }
}
XMLPayment.prototype.delete_bank = function()
{
    try {
        let bank_id=$('bank_account_id').value;
        if ( bank_id == "") return false;
        var queryString = {
            act: 'delete_bank',
            ac: access_code,
            gDossier: dossier_id,
            plugin_code: plugin_code,
            bank_id:bank_id
        };
        var here=this;
        new Ajax.Request("ajax.php",{
            method:'GET',
            parameters:queryString,
            onSuccess:function (req) {
                if (req.responseText == "OK") {
                   for (let i=0;i < $('bank_account_id').options.length;i++) {
                        if ( $('bank_account_id').options[i].value==bank_id) {
                            $('bank_account_id').remove(i)
                        }
                   }
                    $('bank_account_id').value=-1;
                    here.change_bank();
                }
            }
        })
    } catch (e) {
        console.error(e.message)
    }
    return false;
}
/**
 * Save the bank info (Bank account + Status + Date dépot + comment)
 */
XMLPayment.prototype.save_bank = function () {
    let nb_err = this.check_input_bank();

    if (nb_err > 0) {
        return false;
    }
    try {

        waiting_box();

        var input = $('form_save_bank_formid').serialize(true);
        var queryString = {
            act: 'save_bank',
            ac: access_code,
            gDossier: dossier_id,
            plugin_code: plugin_code
        };

        var merge = {...queryString, ...input};
        var action = new Ajax.Request(
            "ajax.php",
            {
                method: 'POST',
                parameters: merge,
                onFailure: ajax_misc_failure,
                onSuccess: function (req) {
                    remove_waiting_box();
                    if (req.responseText == 'NOCONX') {
                        reconnect();
                        return false;
                    }
                    let json = req.responseJSON;
                    $('bank_account_id').update(json['select']);
                    $('bank_account_id').setStyle('font-style:normal');
                }
            }
        );
    } catch (e) {
        console.error(e.message);
        return false;
    }
    return true;
}
/***
 * complete info for payement from operation in accountancy
 * @param int payment_detail_id SQL. xmlpayment.payment_detail.d_id
 */
XMLPayment.prototype.copy_info_payment = function (payment_detail_id) {
    try {

        let njr_id=document.getElementById('d_jr_id');

        if ( njr_id.value == "") {alert_box('Aucune opération demandée') ;return}
        var queryString = {
            act: 'copy_info_payment',
            ac: access_code,
            gDossier: dossier_id,
            plugin_code: plugin_code,
            jr_id:njr_id.value,
            d_id:payment_detail_id

        };
        waiting_box();
        var action = new Ajax.Request(
            "ajax.php",
            {
                method: 'GET',
                parameters: queryString,
                onFailure: ajax_misc_failure,
                onSuccess: function (req) {
                    remove_waiting_box();
                    if (req.responseText == 'NOCONX') {
                        reconnect();
                        return false;
                    }
                    let json=req.responseJSON;
                    $('fiche_id').value=json['qcode'];
                    if (json['bank'] !='' ) $('d_bank_account').value=json['bank'];
                    if (json['amount'] !='' ) $('d_amount').value=json['amount'];
                    if (json['msg'] !='' ) $('d_message').value=json['msg'];
                }
            }
        );
    } catch (e) {
        console.error(e.message);
        return false;
    }

}
/**
 * Show the dialog box for searching an operation , give as parameter the DOM ID of the field that
 * will contains the selected operation, starts with the amount in the INPUT ID=D_AMOUNT.
 * @see PHP IConcerned : function name (search_reconcile) cannot be changed
 * @param {string }dom_id Id of DOMElement that will contain the result
 *
 */
XMLPayment.prototype.search_reconcile = function (dom_id) {
    try {
        var dgbox='search_reconcile_dg';
        var amount=$('d_amount').value;
        var queryString = {
            act: 'search_reconcile',
            ac: access_code,
            gDossier: dossier_id,
            plugin_code: plugin_code,
            target:dgbox,
            ctlc:dom_id,
            amount_min:amount,
            amount_max:amount,
        };

        waiting_box();
        removeDiv(dgbox);
        var action = new Ajax.Request(
            "ajax.php",
            {
                method: 'GET',
                parameters: queryString,
                onFailure: ajax_misc_failure,
                onSuccess: function (req) {
                    remove_waiting_box();
                    if (req.responseText == 'NOCONX') {
                        reconnect();
                        return;
                    }
                    var y=calcy(150);
                    var div_style="position:absolute;"+";top:"+y+"px";
                    add_div({id: dgbox, cssclass: 'inner_box', html: loading(), style: div_style, drag: true});
                    $(dgbox).update(req.responseText);
                    $(dgbox).show();
                }
            }
        );
    } catch (e) {
        console.error(e.message);
    }
}
/**
 * put in the DomElement (dom_id) the JRN.JR_ID of the operation
 * @param DOM Form object of the search
 */
XMLPayment.prototype.set_reconcile=function (domObject)
{
    try {
        // Dialog box : search + result
        var dgbox = domObject['target'].value;

        var aCheckBox = document.getElementsByTagName('input');
        var nb_checkbox = aCheckBox.length;
        for (var i = 0; i < nb_checkbox; i++) {
            if (aCheckBox[i].type != "checkbox") continue;
            if (aCheckBox[i].checked == false) continue;
            if (aCheckBox[i].id.startsWith('jr_concerned') == false) continue;
            let str_operation_id = new String(aCheckBox[i].id);
            let hidden = domObject['ctlc'].value;
            $(hidden).value = str_operation_id.replace("jr_concerned", '');
            removeDiv(dgbox);
            return false;
        }
    }catch (e) {
        console.error(e.message)
        return false;
    }
}
/**
 *
 * @param domObject
 */
XMLPayment.prototype.search_operation = function (domObject)
{
    try {
        var dgbox='search_reconcile_dg';
        var queryString = {
            act: 'search_reconcile',
            ac: access_code,
            gDossier: dossier_id,
            plugin_code: plugin_code,
            target:dgbox
        };
        var form=domObject.serialize(true)
        var merge={...queryString,...form};
        waiting_box();
        var action = new Ajax.Request(
            "ajax.php",
            {
                method: 'GET',
                parameters: merge,
                onFailure: ajax_misc_failure,
                onSuccess: function (req) {
                    remove_waiting_box();
                    if (req.responseText == 'NOCONX') {
                        reconnect();
                        return;
                    }
                    $(dgbox).update(req.responseText);
                }
            }
        );
    } catch (e) {
        console.error(e.message);
    }
}

/**
 * delete a listing
 * @param list_id int PK xmlpayment.payment
 */
XMLPayment.prototype.list_delete=function(list_id) {
    try {

        var queryString = {
            act: 'list_delete',
            ac: access_code,
            gDossier: dossier_id,
            plugin_code: plugin_code,
            list_id:list_id
        };

        waiting_box();
        var action = new Ajax.Request(
            "ajax.php",
            {
                method: 'GET',
                parameters: queryString,
                onFailure: ajax_misc_failure,
                onSuccess: function (req) {
                    remove_waiting_box();
                    if (req.responseText == 'NOCONX') {
                        reconnect();
                        return;
                    }
                    $('xmlpy'+list_id).remove();
                    smoke.signal(`Liste ${list_id} effacée`,function(){},{duration:1500});
                }
            }
        );
    } catch (e) {
        console.error(e.message);
    }
}
/**
 * Calls a dialog box for searching operation , then when the operations are selected and the form
 * submitted, the selected operation will be added to the current list (no duplicate)
 * calls ajax act  = ajax_search_multi_operation.php
 * @param domObject
 */
XMLPayment.prototype.search_multi_operation = function (domObject) {
    try {
        var dgbox = "search_multi_operation_dg";
        var queryString = {
            act: 'search_multi_operation',
            ac: access_code,
            gDossier: dossier_id,
            plugin_code: plugin_code,
            target:dgbox
        };
        var form=domObject.serialize(true)
        var merge={...queryString,...form};
        waiting_box();
        var action = new Ajax.Request(
            "ajax.php",
            {
                method: 'GET',
                parameters: merge,
                onFailure: ajax_misc_failure,
                onSuccess: function (req) {
                    remove_waiting_box();
                    if (req.responseText == 'NOCONX') {
                        reconnect();
                        return;
                    }
                    $(dgbox).update(req.responseText);
                }
            }
        );
    } catch (e) {
        console.error(e.message);
    }
}
/**
 * Show the dialog box for searching several operations to add them to the list ,
 * calls ajax act  = ajax_search_multi_operation.php
 *
 * @param list_id int PAYMENT.P_ID
 * @param mtable_id string MTable Object prefix id to refresh
 */
XMLPayment.prototype.showSearch_multi_operation = function (list_id , mtable_id) {
    try {
        var dgbox='search_multi_operation_dg';
        var queryString = {
            act: 'search_multi_operation',
            ac: access_code,
            gDossier: dossier_id,
            plugin_code: plugin_code,
            target:dgbox,
            list_id: list_id,
            mtable_id:mtable_id
        };

        waiting_box();
        removeDiv(dgbox);
        var action = new Ajax.Request(
            "ajax.php",
            {
                method: 'GET',
                parameters: queryString,
                onFailure: ajax_misc_failure,
                onSuccess: function (req) {
                    remove_waiting_box();
                    if (req.responseText == 'NOCONX') {
                        reconnect();
                        return;
                    }
                    var y=calcy(100);
                    var div_style="position:absolute;"+";top:"+y+"px";
                    add_div({id: dgbox, cssclass: 'inner_box', html: loading(), style: div_style, drag: false});
                    $(dgbox).update(req.responseText);
                    $(dgbox).show();
                }
            }
        );
    } catch (e) {
        console.error(e.message);
    }
}
/**
 *
 * @param domElement_form
 */
XMLPayment.prototype.payment_add_list=function(domElement_form) {
    	try
    		{
                var dgbox='search_multi_operation_dg';
    	        waiting_box();

    	        // For form , most of the parameters are in the FORM
    	        // method is then POST
    	        var form_param=domElement_form.serialize(true);

    	       var queryString= {
    	               act: 'payment_add_list',
                       ac: access_code,
                       gDossier: dossier_id,
                       plugin_code: plugin_code,
    	            };
               var param=Object.assign(queryString,form_param);
    	        var action = new Ajax.Request(
    					  "ajax.php" ,
    					  {
    					      method:'POST',
    					      parameters:param,
    					      onFailure:ajax_misc_failure,
    					      onSuccess:function(req){
    							remove_waiting_box();
    	                        if (req.responseText == 'NOCONX') {
    	                            reconnect();
    	                            return;
    	                        }

                                removeDiv(dgbox);
                                $('tb'+domElement_form['mtable_id'].value).update(req.responseText);

    					      }
    					  }
    	              );
    		}catch( e)
    		{
    			alert_box(e.message);
    		}
}


xmlPayment = new XMLPayment();
